loadFillTypes = {}

local modDirectory = g_currentModDirectory

function loadFillTypes.loadFillTypesFromXML(self, superFunc)

    superFunc(self)

    if fileExists(modDirectory.."xml/fillTypes.xml") then
        local fillTypesXML = loadXMLFile("fillTypes", modDirectory.."xml/fillTypes.xml")

	    g_fillTypeManager:loadFillTypes(fillTypesXML, modDirectory , false, "Haylage_22")
		
		local path = "map.fillTypes.fillType("
		local i = 0
		while true do
			local fillTypeName = getXMLString(fillTypesXML, path..i..")#name")
			if fillTypeName == nil or fillTypeName == "" then
				break
			end
			local windrowLiterPerSqm = getXMLFloat(fillTypesXML, path..i..").maizePlus#windrowLiterPerSqm")
			if windrowLiterPerSqm ~= nil then
				g_fillTypeManager.fillTypes[g_fillTypeManager:getFillTypeIndexByName(fillTypeName)].windrowLiterPerSqm = windrowLiterPerSqm
			end
			i = i+1
		end
		
		path = "map.additionalWindrows.windrow("
		i = 0
		loadFillTypes.additionalWindrows = {}
		while true do
			local fillTypeName = getXMLString(fillTypesXML, path..i..")#name")
			if fillTypeName == nil or fillTypeName == "" then
				break
			end
			local fruitType = getXMLString(fillTypesXML, path..i..")#fruitType")
			
			if loadFillTypes.additionalWindrows[fruitType] == nil then
				loadFillTypes.additionalWindrows[fruitType] = {}
			end

			table.insert(loadFillTypes.additionalWindrows[fruitType], g_fillTypeManager:getFillTypeIndexByName(fillTypeName))
			
			i = i+1
		end		
		
	    delete(fillTypesXML)
    else
        print("Warning: Can't load '"..tostring(modDirectory.."xml/fillTypes.xml").."' no custom FillTypes will be loaded!")
    end
end
FillTypeManager.loadDefaultTypes = Utils.overwrittenFunction(FillTypeManager.loadDefaultTypes, loadFillTypes.loadFillTypesFromXML)

function loadFillTypes.getFillTypeLiterPerSqm(self, superFunc, fillType, defaultTo)
	
	local returnValue = superFunc(self, fillType, defaultTo);
	
	if returnValue == defaultTo then 
		local fillType = g_fillTypeManager.fillTypes[fillType]
		if fillType.windrowLiterPerSqm ~= nil then
			return fillType.windrowLiterPerSqm
		end
	end
	
	return returnValue
end
FruitTypeManager.getFillTypeLiterPerSqm = Utils.overwrittenFunction(FruitTypeManager.getFillTypeLiterPerSqm, loadFillTypes.getFillTypeLiterPerSqm)